package Filesystem

import (
	"os"

	bolt "go.etcd.io/bbolt"
)

func AddFileToBucket(bucket *bolt.Bucket, filePath string) error {
	var (
		fileObject      FileObject
		fileObjectBytes []byte
		e               error
	)
	fileObject, e = CreateFileObject(filePath)
	if os.IsNotExist(e) {
		return nil
	}
	if e != nil {
		return nil
	}

	fileObjectBytes, e = fileObject.ToBytes()
	if e != nil {
		return e
	}

	return bucket.Put([]byte(StripRootDir(filePath)), fileObjectBytes)
}

func RemoveFileFromBucket(bucket *bolt.Bucket, filePath string) error {
	return bucket.Delete([]byte(StripRootDir(filePath)))
}
